local auto, assign

function auto(tab, key)
  return setmetatable({}, {
          __index = auto,
          __newindex = assign,
          __call = function() return function() end end,
          parent = tab,
          key = key
  })
end

local meta = {__index = auto}

-- The if statement below prevents the table from being
-- created if the value assigned is nil. This is, I think,
-- technically correct but it might be desirable to use
-- assignment to nil to force a table into existence.

function assign(tab, key, val)
-- if val ~= nil then
  local oldmt = getmetatable(tab)
  oldmt.parent[oldmt.key] = tab
  setmetatable(tab, meta)
  tab[key] = val
-- end
end

function AutoTable()
  return setmetatable({}, meta)
end
